> ## Documentation Index
> Fetch the complete documentation index at: https://developers.stellar.org/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve a Ledger's Operations

> This endpoint returns successful operations in a specific ledger.



## OpenAPI

````yaml openapi/horizon/bundled.yml GET /ledgers/{sequence}/operations
openapi: 3.1.0
info:
  title: Horizon
  version: 0.0.1
  summary: >-
    Horizon provides an HTTP API to data in the Stellar network. It ingests and
    re-serves the data produced by the Stellar network in a form that is easier
    to consume by the average application relative to the performance-oriented
    data representations used by Stellar Core. This API serves the bridge
    between apps and Stellar Core. Projects like wallets, decentralized
    exchanges, and asset issuers use Horizon to submit transactions, query an
    account balance, or stream events like transactions to an account.
  description: >
    Horizon provides an HTTP API to data in the Stellar network. It ingests and
    re-serves the data produced by the Stellar network in a form that is easier
    to consume by the average application relative to the performance-oriented
    data representations used by [Stellar
    Core](https://developers.stellar.org/network/core-node). This API serves the
    bridge between apps and Stellar Core. Projects like wallets, decentralized
    exchanges, and asset issuers use Horizon to submit transactions, query an
    account balance, or stream events like transactions to an account.


    Horizon can be accessed via cURL, a browser, or one of the [Stellar
    SDKs](https://developers.stellar.org/docs/tools/sdks). To reduce the
    complexity of your project, we recommend you use an SDK instead of making
    direct API calls.


    This guide describes how to administer a production Horizon instance (refer
    to the [Developers'
    Blog](https://stellar.org/blog/developers/a-new-sun-on-the-horizon) for some
    background on the performance and architectural improvements of this major
    version bump). For information about developing on the Horizon codebase,
    check out the [Development
    Guide](https://github.com/stellar/stellar-horizon/blob/main/DEVELOPING.md).


    Before we begin, it's worth reiterating the sentiment echoed in the [Core
    Node](https://developers.stellar.org/network/core-node) documentation: **we
    do not endorse running Horizon backed by a standalone Stellar Core
    instance**, and especially not by a _validating_ Stellar Core. These are two
    separate concerns, and decoupling them is important for both reliability and
    performance. Horizon instead manages its own, pared-down version of Stellar
    Core optimized for its own subset of needs (we'll refer to this as a
    "Captive Core" instance).
  termsOfService: https://stellar.org/terms-of-service
  contact:
    name: Stellar Development Foundation
    url: https://stellar.org
    email: hello@stellar.org
  license:
    name: Apache 2.0
    identifier: Apache-2.0
servers:
  - url: https://horizon-testnet.stellar.org
    description: The Testnet Network
  - url: https://horizon-futurenet.stellar.org
    description: The Futurenet network
security: []
tags:
  - name: Accounts
    description: >-
      Users interact with the Stellar network through accounts. Everything else
      in the ledger—assets, offers, trustlines, etc. are owned by accounts, and
      accounts must authorize all changes to the ledger through signed
      transactions.
  - name: Assets
    description: >-
      Assets are representations of value issued on the Stellar network. An
      asset consists of a type, code, and issuer.
  - name: Claimable Balances
    description: >-
      A Claimable Balance represents the transfer of ownership of some amount of
      an asset. Claimable balances provide a mechanism for setting up a payment
      which can be claimed in the future. This allows you to make payments to
      accounts which are currently not able to accept them.
  - name: Effects
    description: >-
      Effects represent specific changes that occur in the ledger as a result of
      successful operations, but are not necessarily directly reflected in the
      ledger or history, as transactions and operations are.
  - name: Fee Stats
    description: >-
      Fee stats are used to predict what fee to set for a transaction before
      submitting it to the network.
  - name: Liquidity Pools
    description: >-
      Liquidity Pools provide a simple, non-interactive way to trade large
      amounts of capital and enable high volumes of trading.
  - name: Ledgers
    description: >-
      Each ledger stores the state of the network at a point in time and
      contains all the changes - transactions, operations, effects, etc. - to
      that state.
  - name: Offers
    description: >-
      Offers are statements about how much of an asset an account wants to buy
      or sell.
  - name: Operations
    description: >-
      Operations are objects that represent a desired change to the ledger:
      payments, offers to exchange currency, changes made to account options,
      etc. Operations are submitted to the Stellar network grouped in a
      Transaction.
  - name: Order Books
    description: An order book is a collections of offers for a specific pair of assets.
  - name: Paths
    description: >-
      Paths provide information about potential path payments. A path can be
      used to populate the necessary fields for a path payment operation.
  - name: Payments
    description: >-
      Payments are objects that represent balance transfer from one address to
      another. Payments are submitted to the Stellar network grouped in a
      Transaction.
  - name: Trade Aggregations
    description: >-
      A trade aggregation represents aggregated statistics on an asset pair
      (base and counter) for a specific time period. Trade aggregations are
      useful to developers of trading clients and provide historical trade data.
  - name: Trades
    description: >-
      When an offer is fully or partially fulfilled, a trade happens. Trades can
      also be caused by successful path payments, because path payments involve
      fulfilling offers. A trade occurs between two parties—base and counter.
      Which is which is either arbitrary or determined by the calling query.
  - name: Transactions
    description: >-
      Transactions are commands that modify the ledger state and consist of one
      or more operations.
paths:
  /ledgers/{sequence}/operations:
    get:
      tags:
        - Ledgers
      summary: Retrieve a Ledger's Operations
      description: This endpoint returns successful operations in a specific ledger.
      operationId: RetrieveALedgersOperations
      parameters:
        - $ref: '#/components/parameters/SequenceParam'
        - $ref: '#/components/parameters/CursorParam'
        - $ref: '#/components/parameters/OrderParam'
        - $ref: '#/components/parameters/LimitParam'
        - $ref: '#/components/parameters/IncludeFailedParam'
        - $ref: '#/components/parameters/JoinParam'
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Operation'
              examples:
                RetrieveALedgersOperations:
                  $ref: '#/components/examples/RetrieveALedgersOperations'
components:
  parameters:
    SequenceParam:
      name: sequence
      in: path
      required: true
      description: The sequence number of a specific ledger.
      schema:
        type: integer
        example: 0
    CursorParam:
      name: cursor
      in: query
      required: false
      description: >-
        A number that points to a specific location in a collection of responses
        and is pulled from the paging_token value of a record.
      schema:
        type: integer
        example: 6606617478959105
    OrderParam:
      name: order
      in: query
      required: false
      description: >-
        A designation of the order in which records should appear. Options
        include `asc` (ascending) or `desc` (descending). If this argument isn’t
        set, it defaults to `asc`.
      schema:
        type: string
        enum:
          - asc
          - desc
    LimitParam:
      name: limit
      in: query
      required: false
      description: >-
        The maximum number of records returned. The limit can range from 1 to
        200 - an upper limit that is hardcoded in Horizon for performance
        reasons. If this argument isn’t designated, it defaults to 10.
      schema:
        type: integer
        example: 10
    IncludeFailedParam:
      name: include_failed
      in: query
      required: false
      description: >-
        Set to true to include failed operations in results. Options include
        true and false.
      schema:
        type: boolean
        enum:
          - true
          - false
    JoinParam:
      name: join
      in: query
      required: false
      description: >-
        Set to transactions to include the transactions which created each of
        the operations in the response.
      schema:
        type: string
        enum:
          - transactions
  schemas:
    Operation:
      type: object
      properties:
        _links:
          type: object
          properties:
            effects:
              $ref: '#/components/schemas/link'
            precedes:
              $ref: '#/components/schemas/link'
            self:
              $ref: '#/components/schemas/link'
            succeds:
              $ref: '#/components/schemas/link'
            transaction:
              $ref: '#/components/schemas/link'
        id:
          $ref: '#/components/schemas/id'
        paging_token:
          $ref: '#/components/schemas/paging_token'
        type_i:
          type: number
          example: 0
        type:
          type: string
          example: create_account
    link:
      type: object
      properties:
        href:
          type: string
          format: link
        templated:
          type: boolean
      required:
        - href
    id:
      type: string
    paging_token:
      type: string
  examples:
    RetrieveALedgersOperations:
      value:
        _links:
          self:
            href: >-
              https://horizon-testnet.stellar.org/ledgers/27147222/operations?cursor=&limit=2&order=asc
          next:
            href: >-
              https://horizon-testnet.stellar.org/ledgers/27147222/operations?cursor=116596430667259905&limit=2&order=asc
          prev:
            href: >-
              https://horizon-testnet.stellar.org/ledgers/27147222/operations?cursor=116596430667255809&limit=2&order=desc
        _embedded:
          records:
            - _links:
                self:
                  href: >-
                    https://horizon-testnet.stellar.org/operations/116596430667255809
                transaction:
                  href: >-
                    https://horizon-testnet.stellar.org/transactions/3a644389bbec63dd2b107a03c16711563fc549daa7b7f56f951a2e470f81f2e0
                effects:
                  href: >-
                    https://horizon-testnet.stellar.org/operations/116596430667255809/effects
                succeeds:
                  href: >-
                    https://horizon-testnet.stellar.org/effects?order=desc&cursor=116596430667255809
                precedes:
                  href: >-
                    https://horizon-testnet.stellar.org/effects?order=asc&cursor=116596430667255809
              id: '116596430667255809'
              paging_token: '116596430667255809'
              transaction_successful: true
              source_account: GDQWI6FKB72DPOJE4CGYCFQZKRPQQIOYXRMZ5KEVGXMG6UUTGJMBCASH
              type: payment
              type_i: 1
              created_at: '2019-12-06T23:05:38Z'
              transaction_hash: 3a644389bbec63dd2b107a03c16711563fc549daa7b7f56f951a2e470f81f2e0
              asset_type: credit_alphanum4
              asset_code: NODL
              asset_issuer: GB2Y3AWXVROM2BHFQKQPTWKIOI3TZEBBD3LTKTVQTKEPXGOBE742NODL
              from: GDQWI6FKB72DPOJE4CGYCFQZKRPQQIOYXRMZ5KEVGXMG6UUTGJMBCASH
              to: GAD35Y7AEQYS4WNZND5OV7HQ6ALBDDNTNFO2TN2CM4ERE7ZV4FJBNXZ6
              amount: '0.0000077'
            - _links:
                self:
                  href: >-
                    https://horizon-testnet.stellar.org/operations/116596430667259905
                transaction:
                  href: >-
                    https://horizon-testnet.stellar.org/transactions/83eabfa824b57436eda49bb9ac28675285f6d945325f69db41792078a83d3479
                effects:
                  href: >-
                    https://horizon-testnet.stellar.org/operations/116596430667259905/effects
                succeeds:
                  href: >-
                    https://horizon-testnet.stellar.org/effects?order=desc&cursor=116596430667259905
                precedes:
                  href: >-
                    https://horizon-testnet.stellar.org/effects?order=asc&cursor=116596430667259905
              id: '116596430667259905'
              paging_token: '116596430667259905'
              transaction_successful: true
              source_account: GBE63IHPHXHKQHIF7L5P5MGOV4MMDYE6RGZCJYWJPBRQZDJ5MOAPOX7A
              type: manage_offer
              type_i: 3
              created_at: '2019-12-06T23:05:38Z'
              transaction_hash: 83eabfa824b57436eda49bb9ac28675285f6d945325f69db41792078a83d3479
              amount: '0.0000023'
              price: '0.0484621'
              price_r:
                'n': 484621
                d: 10000000
              buying_asset_type: native
              selling_asset_type: credit_alphanum4
              selling_asset_code: RMT
              selling_asset_issuer: GDEGOXPCHXWFYY234D2YZSPEJ24BX42ESJNVHY5H7TWWQSYRN5ZKZE3N
              offer_id: 0

````